                        XPACKET PROTOCOL
                     by: Carl Moreschi, N4PY


This documemnt decribes a protocol to be used with Packet Radio to transfer
binary files in an efficient manner.  The protocol gets its roots from XMODEM
protocol and attempts to alter and enhance that protocol to better fit the
packet radio environment.

The protocol is simple and is receiver driven. It goes like this:

1.  The receiver initiates the transfer by sending NAK (21) to the sender to
    signify ready.  The NAK is repeated every 30 seconds until a packet is
    received from the sender.

2.  When the sender receives the NAK, the sender sends the file header to the
    receiver.  The file header looks like this:

     SOH            one byte (value 01)
     Filename       varible bytes consisting of the file
                    name and extender in ascii

3.  The sender then follows the header immediately with the file data blocks.
    A file data block is up to 130 bytes and appears as follows:

     STX            one byte (value 02)
     Count          one byte (value 01 to 128, usually 128)
     Data           data bytes (1 to 128 bytes according to count)

4.  The sender continues to send data blocks with 128 bytes of data until the
    end of file is reached.  The last block may be less then 128 bytes.  When
    all the data blocks have been sent, the sender finishes the transfer by
    sending an ending sequence as follows:

     EOT            one byte (value 04)

5.  While the sender is sending out the blocks of data, the sender checks
    between blocks for receiving a CAN (24).  If a CAN is received the
    transmission is aborted.  In addition the sender may abort the transfer by
    sending a CAN as a one byte block to the receiver.  Thus either side may
    abort the transfer.

6.  The receiver receives the file header and data blocks and builds a
    corresponding file.  It is the option of the receiver to name the newly
    received file the same as the file header name or name the newly received
    file some other name.

                                 Carl Moreschi
                                 N4PY
                                 October 6, 1985
